// MD5.cpp
//

#include "StdAfx.h"
#include "MD5.h"

unsigned char PADDING[64] = {
	0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

void MD5Init(MD5_CTX * context)
{
	context->count[0] = context->count[1] = 0;

	context->state[0] = 0x67452301;
	context->state[1] = 0xefcdab89;
	context->state[2] = 0x98badcfe;
	context->state[3] = 0x10325476;
}

void MD5Transform(DWORD state[4], unsigned char block[64])
{
	__asm
	{
	pushad
	mov edi,block
	mov esi,state
	mov eax,[esi]
	mov ebx,[esi+4]
	mov ecx,[esi+8]
	mov edx,[esi+12]

	MD5_FF(eax,ebx,ecx,edx,0,7,-28955b88h)
	MD5_FF(edx,eax,ebx,ecx,1,12,-173848aah)
	MD5_FF(ecx,edx,eax,ebx,2,17,242070dbh)
	MD5_FF(ebx,ecx,edx,eax,3,22,-3e423112h)
	MD5_FF(eax,ebx,ecx,edx,4,7,-0a83f051h)
	MD5_FF(edx,eax,ebx,ecx,5,12,4787c62ah)
	MD5_FF(ecx,edx,eax,ebx,6,17,-57cfb9edh)
	MD5_FF(ebx,ecx,edx,eax,7,22,-02b96affh)
	MD5_FF(eax,ebx,ecx,edx,8,7,698098d8h)
	MD5_FF(edx,eax,ebx,ecx,9,12,-74bb0851h)
	MD5_FF(ecx,edx,eax,ebx,10,17,-0000a44fh)
	MD5_FF(ebx,ecx,edx,eax,11,22,-76a32842h)
	MD5_FF(eax,ebx,ecx,edx,12,7,6b901122h)
	MD5_FF(edx,eax,ebx,ecx,13,12,-02678e6dh)
	MD5_FF(ecx,edx,eax,ebx,14,17,-5986bc72h)
	MD5_FF(ebx,ecx,edx,eax,15,22,49b40821h)

	MD5_GG(eax,ebx,ecx,edx,1,5,-09e1da9eh)
	MD5_GG(edx,eax,ebx,ecx,6,9,-3fbf4cc0h)
	MD5_GG(ecx,edx,eax,ebx,11,14,265e5a51h)
	MD5_GG(ebx,ecx,edx,eax,0,20,-16493856h)
	MD5_GG(eax,ebx,ecx,edx,5,5,-29d0efa3h)
	MD5_GG(edx,eax,ebx,ecx,10,9,02441453h)
	MD5_GG(ecx,edx,eax,ebx,15,14,-275e197fh)
	MD5_GG(ebx,ecx,edx,eax,4,20,-182c0438h)
	MD5_GG(eax,ebx,ecx,edx,9,5,21e1cde6h)
	MD5_GG(edx,eax,ebx,ecx,14,9,-3cc8f82ah)
	MD5_GG(ecx,edx,eax,ebx,3,14,-0b2af279h)
	MD5_GG(ebx,ecx,edx,eax,8,20,455a14edh)
	MD5_GG(eax,ebx,ecx,edx,13,5,-561c16fbh)
	MD5_GG(edx,eax,ebx,ecx,2,9,-03105c08h)
	MD5_GG(ecx,edx,eax,ebx,7,14,676f02d9h)
	MD5_GG(ebx,ecx,edx,eax,12,20,-72d5b376h)

	MD5_HH(eax,ebx,ecx,edx,5,4,-0005c6beh)
	MD5_HH(edx,eax,ebx,ecx,8,11,-788e097fh)
	MD5_HH(ecx,edx,eax,ebx,11,16,6d9d6122h)
	MD5_HH(ebx,ecx,edx,eax,14,23,-021ac7f4h)
	MD5_HH(eax,ebx,ecx,edx,1,4,-5b4115bch)
	MD5_HH(edx,eax,ebx,ecx,4,11,4bdecfa9h)
	MD5_HH(ecx,edx,eax,ebx,7,16,-0944b4a0h)
	MD5_HH(ebx,ecx,edx,eax,10,23,-41404390h)
	MD5_HH(eax,ebx,ecx,edx,13,4,289b7ec6h)
	MD5_HH(edx,eax,ebx,ecx,0,11,-155ed806h)
	MD5_HH(ecx,edx,eax,ebx,3,16,-2b10cf7bh)
	MD5_HH(ebx,ecx,edx,eax,6,23,04881d05h)
	MD5_HH(eax,ebx,ecx,edx,9,4,-262b2fc7h)
	MD5_HH(edx,eax,ebx,ecx,12,11,-1924661bh)
	MD5_HH(ecx,edx,eax,ebx,15,16,1fa27cf8h)
	MD5_HH(ebx,ecx,edx,eax,2,23,-3b53a99bh)

	MD5_II(eax,ebx,ecx,edx,0,6,-0bd6ddbch)
	MD5_II(edx,eax,ebx,ecx,7,10,432aff97h)
	MD5_II(ecx,edx,eax,ebx,14,15,-546bdc59h)
	MD5_II(ebx,ecx,edx,eax,5,21,-036c5fc7h)
	MD5_II(eax,ebx,ecx,edx,12,6,655b59c3h)
	MD5_II(edx,eax,ebx,ecx,3,10,-70f3336eh)
	MD5_II(ecx,edx,eax,ebx,10,15,-00100b83h)
	MD5_II(ebx,ecx,edx,eax,1,21,-7a7ba22fh)
	MD5_II(eax,ebx,ecx,edx,8,6,6fa87e4fh)
	MD5_II(edx,eax,ebx,ecx,15,10,-01d31920h)
	MD5_II(ecx,edx,eax,ebx,6,15,-5cfebcech)
	MD5_II(ebx,ecx,edx,eax,13,21,4e0811a1h)
	MD5_II(eax,ebx,ecx,edx,4,6,-08ac817eh)
	MD5_II(edx,eax,ebx,ecx,11,10,-42c50dcbh)
	MD5_II(ecx,edx,eax,ebx,2,15,2ad7d2bbh)
	MD5_II(ebx,ecx,edx,eax,9,21,-14792c6fh)

	mov esi,state
	add [esi],eax
	add [esi+4],ebx
	add [esi+8],ecx
	add [esi+12],edx

	popad
	}
}

void MD5Update(MD5_CTX * context, unsigned char * input, unsigned int inputLen)
{
	unsigned int i, index, partLen;

	/* Compute number of bytes mod 64 */
	index = (unsigned int)((context->count[0] >> 3) & 0x3F);

	/* Update number of bits */
	if ((context->count[0] += ((DWORD)inputLen << 3)) < ((DWORD)inputLen << 3))
		context->count[1]++;
	context->count[1] += ((DWORD)inputLen >> 29);

	partLen = 64 - index;

	/* Transform as many times as possible */
	if (inputLen >= partLen)
	{
		memcpy((unsigned char *)&context->buffer[index], (unsigned char *)input, partLen);
		MD5Transform(context->state, context->buffer);
		for (i = partLen; i + 63 < inputLen; i += 64)
			MD5Transform (context->state, &input[i]);
		index = 0;
	}
	else
		i = 0;

	/* Buffer remaining input */
	memcpy((unsigned char *)&context->buffer[index], (unsigned char *)&input[i], inputLen-i);
}

void MD5Final(unsigned char digest[16], MD5_CTX * context)
{
	unsigned char bits[8];
	unsigned int index, padLen;

	/* Save number of bits */
	memcpy(bits, context->count, 8);

	/* Pad out to 56 mod 64.*/
	index = (unsigned int)((context->count[0] >> 3) & 0x3f);
	padLen = (index < 56) ? (56 - index) : (120 - index);
	MD5Update(context, PADDING, padLen);

	/* Append length (before padding) */
	MD5Update(context, bits, 8);

	/* Store state in digest */
	memcpy(digest, context->state, 16);
}
