typedef struct {
	DWORD state[4]; /* state (ABCD) */
	DWORD count[2]; /* number of bits, modulo 2^64 (lsb first) */
	unsigned char buffer[64]; /* input buffer */
} MD5_CTX;

void MD5Init (MD5_CTX *context);
void MD5Transform (DWORD state[4], unsigned char block[64]);
void MD5Update (MD5_CTX *context, unsigned char *input, unsigned int inputLen);
void MD5Final (unsigned char digest[16], MD5_CTX *context);

#define MD5_FF(p1,p2,p3,p4,i,n,Constant) \
	__asm mov esi,p3 \
	__asm xor esi,p4 \
	__asm add p1,[dword ptr edi+i*4] \
	__asm and esi,p2 \
	__asm xor esi,p4 \
	__asm lea p1,[p1+esi+Constant] \
	__asm rol p1,n \
	__asm add p1,p2

#define MD5_GG(p1,p2,p3,p4,i,n,Constant) \
	__asm mov esi,p3 \
	__asm xor esi,p2 \
	__asm add p1,[dword ptr edi+i*4] \
	__asm and esi,p4 \
	__asm xor esi,p3 \
	__asm lea p1,[p1+esi+Constant] \
	__asm rol p1,n \
	__asm add p1,p2

#define MD5_HH(p1,p2,p3,p4,i,n,Constant) \
	__asm mov esi,p4 \
	__asm xor esi,p3 \
	__asm add p1,[dword ptr edi+i*4] \
	__asm xor esi,p2 \
	__asm lea p1,[p1+esi+Constant] \
	__asm rol p1,n \
	__asm add p1,p2

#define MD5_II(p1,p2,p3,p4,i,n,Constant) \
	__asm mov esi,p4 \
	__asm not esi \
	__asm or esi,p2 \
	__asm add p1,[dword ptr edi+i*4] \
	__asm xor esi,p3 \
	__asm lea p1,[p1+esi+Constant] \
	__asm rol p1,n \
	__asm add p1,p2
